/*********************************************************************
 * ChildView.cpp : implementation of the CChildView class
 *
 *********************************************************************/
#include "stdafx.h"

#include "targetver.h"
#include "SteemaChartBugDemo.h"
#include "ChildView.h"

#include "TeeFiles\TeeChartDefines.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


/*********************************************************************
 * CChildView:  Constructor
 *********************************************************************/
CChildView::CChildView()
{
   pChartData     = NULL;
   bInitialized   = false;
}

/*********************************************************************
 * CChildView:  Destructor
 *********************************************************************/
CChildView::~CChildView()
{
   if (pChartData)
   {
      pChartData->DestroyWindow();
      delete pChartData;
      pChartData = NULL;
   }
}


/*********************************************************************
 * CChildView:  OnPaint
 * 
 * Refresh the page
 *********************************************************************/
void CChildView::OnPaint() 
{
   PAINTSTRUCT paintStruct;
   CDC *pDC = BeginPaint(&paintStruct);


   if (!bInitialized)
   {
      bInitialized = CreateChart();
   }

   if (bInitialized)
   {
      CRect rclChart;
      GetClientRect(&rclChart);

      // Draw background
      pDC->FillSolidRect(rclChart, RGB(0xff, 0xff, 0xff));
      pDC->SetTextColor(RGB(0xff, 0x00, 0x00));
      pDC->DrawText(L"Background page -- TeeChart failed to draw", rclChart, DT_VCENTER | DT_CENTER | DT_SINGLELINE);

      // Draw Chart
      HDC hdc = pDC->m_hDC;
      pChartData->Draw((long)hdc, rclChart.left, rclChart.top, rclChart.right, rclChart.bottom);
   }

   EndPaint(&paintStruct);
}



/*********************************************************************
 * CChildView:  CreateChart
 * 
 * Create the chart and the button, the first time paint is called
 *********************************************************************/
bool CChildView::CreateChart()
{
   CRect rclChart;
   GetClientRect(&rclChart);
   rclChart.top = 20;

   if (pChartData == NULL)
   {
      pChartData = new CTChart();
      if (pChartData)
      {
         pChartData->Create(L"Graph", L"Graph", WS_CHILD|WS_CLIPSIBLINGS|WS_CLIPCHILDREN, rclChart, this, IDC_GRAPH, 0);
      }
   }
   
   return (pChartData != NULL);
}


/*********************************************************************
 * CChildView:  Message Map
 *********************************************************************/
BEGIN_MESSAGE_MAP(CChildView, CWnd)
   ON_WM_PAINT()
END_MESSAGE_MAP()

